// bbsc.h
// $Id: bbsc.h,v 1.21 1998/10/14 00:30:33 jyotaro Exp $

#ifndef __BBSC_H__
#define __BBSC_H__

#define CLIENTNAME "StdClient version TEST"
#define VERSION "STBBS Standard Clinet version TEST ("__DATE__" "__TIME__")\nProgrammed by T.Shimada <shima@cup.com>\n\n"

#define MAX_TELEGRAM	10

class StdClient : public Client {
	char cmdline[256];
	char* cmdptr;
public:
	StdClient(int sd);
	void Login(const char* id = "");
	void Run();
	virtual void ReceiveTelegram();
	void printmainmenu();
	void printcolumnedstr(char* buf, int col, char spc = ' ');
	void GetCmdLine(const char* prompt);
	void SetWhat(const char* buf);
	bool CmdLineGetStr(char* buf, int size = 256);
	string CmdLineGetStr();
	int CmdLineGetInt();
	bool who();
	bool SendTelegram(int ch, const char* msg);
	bool UserList();
	bool Telegram();
	bool Enter();
	bool GetMultiLineText(string& text);
	void ShowArticleList(int bnum);
	void ShowArticleHeader(ARTICLEPROPERTY* ap, bool dammy);
	bool ReadFirstMessage(int bnum, int anum, bool prompt = false);
	void ReadNextMessage(bool prompt = false);
	bool ReadMessage();
	bool NewMessages();
	int BoardSelect();
	int EnterArticle(int bnum, char* subject);
	bool EnterArticle();
	bool EnterReplyArticle(int bnum, int anum);
	bool EnterReplyArticle();
	void KillArticle();
	bool SendMail();
	void Chat();
	void Install();
	bool InputUserID(char* buf);
	bool ShowProfile(const char* targetid);
	void Profile();
	bool Apply();
	void FileList(int bnum = 0);
	bool FileNew();
	void File();
	void Download(char type);
	void Upload(char type);
	bool AskYesNo(const char* prompt, bool bdefault);
	void FileBoard(int bnum);
	void last();
	char* create_password(char* password, int size);
	
	void quit();
	void status();
	void Admin();
	bool parse();

	bool Freetalk();
	bool FT_EnterArticle(const int bnum);
	bool FT_ReadArticle(const int bnum, int anum = -21);
	virtual void ShowFreetalkArticle(int bnum, int anum, char* id, char* handle, char* article, time_t atime, int code);
};

#endif // __BBSC_H__
