/* $Log: stbbs.h,v $
/* Revision 1.27  1998/10/14 00:30:34  jyotaro
/* ¿includeǤʤ褦ˤ
/*
 * Revision 1.26  1998/10/01 06:02:49  jyotaro
 * getfilenamebasenameȤ̾ˤ
 * ⤷ǤbasenameƤ餽Ȥ褦ˤ
 *
 * Revision 1.25  1998/09/28 03:54:59  jyotaro
 * FullPathե̾Фgetfilenameɲ
 *
 * Revision 1.24  1998/09/28 02:24:45  jyotaro
 * BOOL -> bool, TRUE -> true, FALSE -> false ˤ
 *
 * Revision 1.23  1998/04/25 15:04:56  jyotaro
 * VC++ ǥѥǤ褦ˡٹ
 *
 * Revision 1.22  1998/02/12 03:03:15  shimarin
 * WebSTBBSɲäȤȼ¾ʬν
 *
 * Revision 1.21  1998/02/10 12:53:15  jyotaro
 * GetArticle() طΰޤȤˤ.
 * Article βԤ̵뤵줿Х.
 *
 * Revision 1.20  1998/02/10 00:51:11  jyotaro
 * "25-" protocol θľ.
 * article Ρإåοήѻ.
 * ARTICLEPROPERTY ν.
 *
 * Revision 1.19  1998/02/08 04:43:30  shimarin
 * string饹Ȥäeuc<->ShiftjisѴ롼ɲ
 *
 * Revision 1.18  1998/02/08 03:13:29  shimarin
 * ưŪconfigԤ褦ѹ
 *
 * Revision 1.17  1998/02/07 18:48:20  shimarin
 * -O2ץ(㳰ߤǤʤ뤿)
 *
 * $Id: stbbs.h,v 1.27 1998/10/14 00:30:34 jyotaro Exp $
 */

/***************************************************************************
  Global macro definitions of STBBS
 ***************************************************************************/

#ifndef  __STBBS_H__
#define  __STBBS_H__

#define HOSTLEN 128
#define BUFSIZE	32768
#define MAXPATH	256

#define IDLEN		16
#define HANDLELEN	24
#define PASSWDLEN	15
#define MEMOLEN		30
#define WHATLEN		16
#define TTYLEN		16

#ifndef bzero
#define bzero(s, n)	memset((s), 0, (n))
#endif

#if defined(__WIN32__) || defined(WIN32) || defined(_WIN32)
inline int close(SOCKET s) { return closesocket(s); }
#define usleep(s)	Sleep(s)
#define DONTHAVE_UNIXSTDIO
#endif

#define euc_kana		(0x8e)
#define iseuc(c)		(0xa1 <= ((unsigned char)c) && ((unsigned char)c) <= 0xfe)
#define issjis(c)		((0x81 <= ((unsigned char)c) && ((unsigned char)c) <= 0x9f) || (0xe0 <= ((unsigned char)c) && ((unsigned char)c) <= 0xfc))
#define iseuckana(c)	(((unsigned char) (c)) == euc_kana)
#define issjiskana(c)	((0xa0 <= ((unsigned char) (c)) && ((unsigned char) (c)) <= 0xdf))

#define SHOW_DOC(doc) { for (int i = 0; doc[i][0]; i++) puts(doc[i]); } 

/***************************************************************************
  Type definitions of STBBS
 ***************************************************************************/

#ifndef bool
#  if defined(__WIN32__) || defined(WIN32) || defined(_WIN32)
#    define bool BOOL
#    define true TRUE
#    define FALSE false
#  else
#    define bool int
#    define true 1
#    define false 0
#  endif
#endif // bool

struct CHINFO {
	int ch;
	char id[IDLEN];
	char handle[HANDLELEN];
	char what[WHATLEN];
	char memo[MEMOLEN];
	char tty[TTYLEN];
	char dev[TTYLEN];
	CHINFO(){ ch = -1; id[0] = handle[0] = what[0] = memo[0] = tty[0] = dev[0] = '\0';}
};

struct ARTICLEPROPERTY {
	int bnum;
	int anum;
	char bname[32];
	char senderid[IDLEN];
	char senderhandle[HANDLELEN];
	time_t postedtime;
//	char date[9];
//	char time[9];
	char subject[81];
	ARTICLEPROPERTY(){ bnum = anum = postedtime = 0; bname[0] = senderid[0] = senderhandle[0] = subject[0] = '\0';}
};

typedef struct tagFILEPROPERTY {
	int bnum, anum;
	char bname[32];
	char senderid[17], senderhandle[24];
	time_t postedtime;
	char date[9], time[9];
	char subject[81];
	char filename[256];
	int size, getcount;
} FILEPROPERTY;

/***************************************************************************
  Definitions of exception-related class
 ***************************************************************************/

#if !defined(__GNUC__) && !defined(__GNUG__)
using namespace std;
#endif

class Exception {
protected:
	string reason;
public:
	Exception() { ; }
	operator const char* () { return reason.c_str(); }
};

class SocketException : public Exception {
public:
	SocketException() : Exception() { ; }
};

/***************************************************************************
  Definitions of class BBSSocket
 ***************************************************************************/
class BBSSocket {
protected:
	int SockDsc;
	char* lpbuf;
	int maxchannel, channelno;
	int userlevel;
//	char id[IDLEN], handle[HANDLELEN];
	CHINFO information;
	bool shiftjis;
	int allocsize, firstalloc, allocstep;
	void resetbuffer();
public:
	BBSSocket(int sd);
	virtual ~BBSSocket();
	void fdset(fd_set* fds) { FD_SET(SockDsc, fds); }
	int fdisset(fd_set* fds) { return FD_ISSET(SockDsc, fds); }
	int GetSockDsc() { return SockDsc; }
	char* GetUserID() { return information.id; }
	char* GetHandle() { return information.handle; }
	char* GetWhat() { return information.what; }
	char* GetMemo() { return information.memo; }
	int GetUserLevel() { return userlevel; }
	virtual int sendsz(char* lpsz, ...);
	void output_file(char* longname, short prefix = 0);
	void outmessagefile(char* dir, char* name, short prefix = 0);
	virtual char* recvsz(unsigned int flags = 0);
	virtual char* recvln(unsigned int flags = 0, timeval* timeout = NULL);

	virtual char* recvbin(unsigned int* psize = NULL, unsigned int flags = 0);
	virtual bool recvfile(const char* filename, unsigned int * psize = NULL, unsigned int flags =0);
	bool sendbin(char* buf, unsigned int size, unsigned int flags = 0);
	bool sendfile(const char* filename, unsigned int flags = 0);
	
	virtual void OnConnectionRefused();

	operator char* () { return lpbuf; }
	operator int ();
	char* GetMessageBody();
	int GetChannelNumber() { return channelno; }
};

/***************************************************************************
  Definitions of class stdiofile
 ***************************************************************************/
class stdiofile {
	FILE* f;
public:
	stdiofile(const char* filename, const char* mode = "r")
	{ f = fopen(filename, mode); }
	stdiofile() { f = NULL; }
	FILE* open(const char* filename, const char* mode = "r")
	{ f = fopen(filename, mode); return f; }
	void close() { if (f) fclose(f); f = NULL; }
	virtual ~stdiofile() { if (f) fclose(f); }
	operator FILE* () { return f; }
	bool readline(string& str);
};

/***************************************************************************
  Definitions of class Hash
 ***************************************************************************/
class Hash : public map< string, string, less<string> > {
	string filename;
public:
	Hash() : map< string, string, less<string> >() {;}
	virtual ~Hash() {;}
	string GetValue(const char* key, const char* defaultvalue);
	int GetValue(const char* key, int defaultvalue);
	void SetValue(const char* key, const char* value);
	void SetValue(const char* key, int value);
	bool Delete(const char* key);
	bool Load(const char* fmt, ...);
	bool Save(const char* fmt, ...);
	bool Flush();
};

/***************************************************************************
  Global prototypes of utilities & misc functions
 ***************************************************************************/
char* euctosjis(char* buf);
char* sjistoeuc(char* buf);
string& euctosjis(string& euc);
string& sjistoeuc(string& sjis);
char* strupr(char* buf);
string format(const char* fmt, ...);

string& strupr(string& str);
string timevoltotime(time_t t);
string timetodate(time_t t);
string timetotime(time_t t);

string itoa(int n);
int atoi(string& s);

#if defined(__WIN32__) || defined(WIN32) || defined(_WIN32)
int strcasecmp(const char* str1, const char* str2);
#endif

time_t GetNewsDate(const char *ln, time_t def);
void beep(unsigned int ms = 1*1000*1000, unsigned int times = 10);

#ifndef HAVE_BASENAME
char* basename(char* path);
#endif

#endif // __STBBS_H__
