#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>
#include <netdb.h>
#include <netinet/in.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <sys/termios.h>
#include <sys/socket.h>
#include <string>
#include <stl.h>
#include "stbbs.h"
#include "config.h"
#include "../bbsc/client.h"

class BoardListClient : public Client {
public:
	virtual void ReceiveTelegram() {;}
	BoardListClient(int sd) : Client(sd) {;}
	virtual void ShowFreetalkArticle(int bnum, int anum, char* id, char* handle, char* article, time_t atime, int code) {;}
};


int main()
{
	int sd = ConnectToService();
	if (sd < 0) { perror("Client:connect");	exit(1); }

	BoardListClient client(sd);

	client.Auth("GUEST", "ssi-user");
	printf("<TABLE border=#000000>\n");
	client.sendsz("BLIST\n");
	while (client.waitfor(22, 18)) {
		char sname[11], lname[32];
		int num, rlevel, wlevel;
		sscanf(client.GetMessageBody(), "%d %[^\t] %[^\t] %d %d", &num, sname, lname, &rlevel, &wlevel);
		char fs[64] = "", fe[64] = "";
		if (wlevel <= 1) {
			strcpy(fs, "<FONT color=#0000ff>");
			strcpy(fe, "</FONT>");
		}
		printf("<TR><TD>%s%02d%s</TD><TD>%s%s%s</TD><TD>%s%s%s</TD></TR>\n", 
			fs, num, fe, fs, sname, fe, fs, lname, fe);
	}
	client.sendsz("QUIT\n");
	printf("</TABLE>\n");
	return 0;
}


