#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

typedef struct tagFTARTICLEPROPERTY {
	char	id[9];
	char	handle[15];
	char	article[80];
	time_t	time;
	char	reserve[20];
} FTARTICLEPROPERTY;

int main(int argc, char* argv[])
{
	if (argc < 2) {
		puts("\nFreetalkArticle => PlaneText converter");
		puts("Programmed by Jyotaro\n");
		puts("Usage : extft [article file]\n");
		return 0;
	}
	FILE* fp = fopen(argv[1],"r");
	if (!fp) {
		printf("Can't open board file.\n");
		return 0;
	}

	FTARTICLEPROPERTY    n;
	int sizenew = sizeof(FTARTICLEPROPERTY);

	while(fread(&n,sizenew,1,fp) == 1) {
		printf("%s\n%s\n%s\n\n",n.id,n.handle,n.article);
	}
	fclose(fp);
}

