#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>
#include <netdb.h>
#include <netinet/in.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <sys/termios.h>
#include <sys/socket.h>
#include <string>
#include <stl.h>
#include "stbbs.h"
#include "config.h"
#include "../bbsc/client.h"

class RecentClient : public Client {
public:
	virtual void ReceiveTelegram() {;}
	RecentClient(int sd) : Client(sd) {;}
	virtual void ShowFreetalkArticle(int bnum, int anum, char* id, char* handle, char* article, time_t atime, int code) {;}
	bool printarticle(int prefix, int exception);
};

bool RecentClient::printarticle(int prefix, int exception)
{
	// prefix դΥå 18-EOMޤɽ
	// exception褿false֤
	int i = 0;
	do {
		recvln();
		if ((int)*this == exception) return false;
		if ((int)*this == prefix) {
			if (i == 0) {
				puts("<font color=#0000ff>");
				puts("<pre>");
			}
			printf("%s\n", GetMessageBody());
			if (i == 2) {
				puts("</pre>");
				puts("</font>");
				puts("<pre>");
			}
			i++;
		}
	} while ((int)*this != 18);
	puts("</pre>");
	return true;
}

int main()
{
	int sd = ConnectToService();
	if (sd < 0) { perror("Client:connect");	exit(1); }

	RecentClient client(sd);

	if (client.Auth("GUEST", "ssi-user") != LOGIN_SUCCESS) return 0;
	puts("<H3>̤ɥܡɰ</H3>");
	puts("<table border=0>");
	puts("<TR><TD><A href=\"#notice\">Τ餻</A></TD><TD></TD></TR>");
	BOARDPROPERTY brd;
	bool bFound = client.MessageBoardFirst(&brd);
	while (bFound) {
		int nn = client.GetNumberOfNewArticle();
		if ( nn > 0) {
			printf("<TR><TD><A href=\"#b%d\">ܡ #%02d: %-8s(%s)</A></TD><TD>...̤ %d</TD></TR>\n", 
				brd.bnum, brd.bnum, brd.sname, brd.lname, nn);
		}
		bFound = client.MessageBoardNext(&brd);
	}
	puts("</table>");
	puts("<HR>");
	puts("<A name=\"notice\"><H3>Τ餻</H3></A>");
	puts("<pre>");
	client.sendsz("OPENING\n");
	client.printmessage(19);
	puts("</pre>");
	bFound = client.MessageBoardFirst(&brd);
	while (bFound) {
		if (client.GetNumberOfNewArticle() > 0) {
			puts("<hr>");
			printf("<A name=\"b%d\"><H3>ܡ #%02d: %-8s(%s)</H3></A>\n", brd.bnum, brd.bnum, brd.sname, brd.lname);
			client.sendsz("READNEW\n0\n");
			while (client.printarticle(27, 35)) {
				client.sendsz("READNEXT\n");
			}
		}
		bFound = client.MessageBoardNext(&brd);
	}
	puts("<HR>");

	client.sendsz("QUIT\n");
	return 0;
}


