// stl-html.h

void print(const string& msg);

// Basic HTML tags
void begin_html(const string title, const string urltojump = "", int sec = 1);
void end_html();
void begin_body(const string& options = "");
void end_body();

string hyperlink(const string& url, const string& word);
string font(const string& fonttype, const string& word);

// Form operations
void begin_form(const string& action);
void end_form();
string edittext(const string& name, const string& value = "", int size = 0);
string editpassword(const string& name, const string& value = "");
string hidden(const string& name, const string& value = "");
string submit(const string& face = "");
string textarea(const string& name, const string& value = "", int rows = 5, int cols = 70);

