/* $Log: freetalk.cpp,v $
/* Revision 1.30  1998/09/28 02:24:44  jyotaro
/* BOOL -> bool, TRUE -> true, FALSE -> false $B$K$7$?(B
/*
 * Revision 1.29  1998/02/08 04:11:04  shimarin
 * class Mutex򡢤äỌ̇̄Τʪˤ
 *
 * Revision 1.28  1998/02/08 03:13:28  shimarin
 * ưŪconfigԤ褦ѹ
 *
 * Revision 1.27  1998/02/07 17:14:06  shimarin
 * κۤäȸ䤹饹 Hashɲä
 *
 * Revision 1.26  1998/01/10 10:38:15  jyotaro
 * CHANNELINFO ѻ. ٤ CHINFO Ǵ褦ˤ.
 *
 * Revision 1.25  1998/01/06 15:49:43  jyotaro
 * Client::GetFreetalkBoardVectorɲäˤѹ.
 *
 * Revision 1.24  1998/01/06 11:54:15  jyotaro
 * ft_editarticle()̵̤ʬ򾯤.
 *
 * Revision 1.23  1997/12/31 20:12:09  jyotaro
 * ext_fgets()ΥǥХå롼(?)ȻפȤ
 *
 * Revision 1.21  1997/12/17 00:50:44  shimarin
 * ͥǽC++㳰ˤäƹԤ褦ˤ
 * pthreadǽȤ鷺kickǤ褦ˤʤ곰ƻ
 *
 * Revision 1.20  1997/12/05 16:43:06  jyotaro
 * Server  Version ɽѹ < ˤɽ褦ˤ
 *
 * Revision 1.19  1997/11/30 23:02:26  jyotaro
 * SYSOP LV  ArticleͿ.
 *
 * Revision 1.18  1997/11/24 21:34:37  jyotaro
 * Freetalk  Article κб.
 *
 * Revision 1.17  1997/11/24 01:31:49  jyotaro
 * 1.SYSOP_LV Ѥƽ񤭴.
 * 2.Install ǫ˽񤤤(
 *
 * Revision 1.15  1997/11/22 23:58:06  shimarin
 * 饹 stdiofile ɲáʤʤꤤʥ饹
 *
 * Revision 1.14  1997/11/22 23:37:16  jyotaro
 * ft_editarticle() .
 *
 * Revision 1.12  1997/11/22 00:56:07  jyotaro
 * 1ԥܡ Article ¸ѹΤ. (FTARTICLEPROPERTYѹ)
 * extft ¸ѹ freetalk.cpp  ¤Τͭ
 * ɬͭ.
 *
 * Revision 1.11  1997/11/11 07:51:02  jyotaro
 * ft_getlasttime ReadProfileIntΰ̵äХ.
 *
 * Revision 1.10  1997/11/10 00:53:37  jyotaro
 * FTGETLTIME ɲ.
 *
 */

#include <pthread.h>
#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <unistd.h>
#include <string>
#include <stl.h>	// ANSI Standard Template Class Library
#include <sys/time.h>

#include "stbbs.h"
#include "config.h"
#include "bbsd.h"

typedef struct tagFTBOARDPROPERTY {
	char bname[32];
	int rlevel;
	int wlevel;
	bool bCug;
} FTBOARDPROPERTY;

typedef struct tagFTARTICLEPROPERTY {
	char   id[9];
	char   handle[15];
	char   article[80];
	time_t time;
	char   reserve[20];
} FTARTICLEPROPERTY;

Mutex FreeTalkLock;		// Mutex of FreeTalk

char* ext_fgets(char* buf, size_t size, FILE* f)
{
	char largebuf[BUFSIZE];
	do {
		if (!fgets(largebuf, sizeof(largebuf), f)) return NULL;
	} while (largebuf[0] == '\n' || largebuf[0] == '#' || largebuf[0] == ';' 
		|| largebuf[0] == ' ' || largebuf[0] == '\t');

	largebuf[strlen(largebuf) - 1] = '\0';
	if (strlen(largebuf) > size - 1) {
		strncpy(buf, largebuf, size);
		buf[size - 1] = '\0';
	} else {
		strcpy(buf, largebuf);
	}
	char* pt = buf;
	char* ptmark = NULL;
	while (*pt) {
		if (*pt == '\t' || *pt == ' ') {
			if (!ptmark) ptmark = pt;
			pt++;
			continue;
		}
		if (*pt == '#' || *pt == ';') { 
			*pt = '\0'; 
			if (ptmark) *ptmark = '\0'; 
			break; 
		} else {
			if (ptmark) ptmark = NULL;
		}
		pt++;
	}
	return buf;
}

bool GetFreetalkBoardProperty(FTBOARDPROPERTY& prop, int bnum)
{
	char buf[MAXPATH];

	sprintf(buf, FREETALKDIR"freetalk.config", bnum);

	stdiofile f;
	if (!f.open(buf)) return false;

	for (int i = 0; i < MAX_FREETALK; i++) {
		if (!ext_fgets(buf, 33, f)) return false;
		strcpy(prop.bname, buf);
		if (!ext_fgets(buf, sizeof(buf), f)) return false;
		prop.rlevel = atoi(buf);
		if (!ext_fgets(buf, sizeof(buf), f)) return false;
		prop.wlevel = atoi(buf);
		if (!ext_fgets(buf, sizeof(buf), f)) return false;
		prop.bCug = atoi(buf);
		if (i == bnum) break;
	}
	return true;
}

void Channel::ft_whatboardis()
{
	sendsz("102-Enter board number.\n");
	int bnum = atoi(recvln());
	FTBOARDPROPERTY prop;
	if (GetFreetalkBoardProperty(prop, bnum) && (prop.rlevel <= userlevel /*|| prop.bCug*/)) {
		sendsz("100-%d\t%s\t%s\t%d\t%d\t%d\n",bnum, "none", prop.bname, prop.rlevel, prop.wlevel, prop.bCug);
		return;
	}
	sendsz("42-No such board.\n");
}

void Channel::ft_boardlist()
{
	FTBOARDPROPERTY prop;
	for (int bnum=0;bnum <= MAX_FREETALK; bnum++) {
		if (GetFreetalkBoardProperty(prop, bnum) && (prop.rlevel <= userlevel /*|| prop.bCug*/))
			sendsz("100-%d\t%s\t%s\t%d\t%d\t%d\n", bnum, "none", prop.bname, prop.rlevel, prop.wlevel, prop.bCug);
	}
	sendsz("18-EOM\n");
}

void Channel::ft_getboardnum()
{
	sendsz("108-%d\n",MAX_FREETALK);
}

void Channel::ft_readarticle()
{
	char fname[MAXPATH];

	sendsz("102-Enter Freetalk board number.\n");
	int bnum = atoi(recvln());

	FTBOARDPROPERTY prop;
	if (!GetFreetalkBoardProperty(prop,bnum) || prop.rlevel > userlevel /*|| prop.bCug*/) {
		sendsz("68-The operation is not permitted for you.\n");
		return;
	}

	sprintf(fname, FREETALKDIR"board%d", bnum);
	FILE* fp = fopen(fname,"r");
	if (!fp) {
		sendsz("103-No messages in this freetalk board.\n");
		return;
	}
	sendsz("104-Enter start article number.\n");

	int pos = atoi(recvln());
	int whence = SEEK_SET;
	size_t size = sizeof(FTARTICLEPROPERTY);
	FTARTICLEPROPERTY article;

	if (pos > 0) pos--;
	if (pos < 0) whence = SEEK_END; 
	fseek(fp,size*pos,whence);
	if (ftell(fp) < 0) rewind(fp);
	while(fread(&article,size,1,fp) == 1) 
		sendsz("101-%d %s\t%s\t%s\t%d\n",(ftell(fp)/size),article.id,article.handle,article.article,article.time);
	sendsz("18-EOM\n");
	fclose(fp);
} 

void Channel::ft_enterarticle()
{
	FTARTICLEPROPERTY article;
	char fname[32];

	sendsz("102-Enter Freetalk board number.\n");
	sprintf(fname, FREETALKDIR"board%d", atoi(recvln()));
	sendsz("105-Enter FreeTalk article.\n");
	FreeTalkLock.Lock();
	FILE* fp = fopen(fname,"a");
	for (;;) { 
		string str = recvln();
		if (str.length() > 63) str[63] = '\0';
		if (str == "//") break;

		strcpy(article.id, information.id);
		strcpy(article.article, str.c_str());
		strcpy(article.handle,information.handle);
		time(&article.time);
		if ((fwrite(&article,sizeof(FTARTICLEPROPERTY),1,fp))!=1) {
			sendsz("9-Operation failed.\n");
			fclose(fp);
			FreeTalkLock.Unlock();
			return;
		}
	}
	fclose(fp);
	FreeTalkLock.Unlock();
	sendsz("8-Succeed.\n");
}

void Channel::ft_numberofnewarticle()
{
	sendsz("102-Enter Freetalk board number.\n");
	int bnum = atoi(recvln());
	char fname[MAXPATH];
	sprintf(fname,FREETALKDIR"board%d",bnum);
	FILE* fp = fopen(fname,"r");
	if (!fp) {
		sendsz("107-0\n");
		return;
	}
	sprintf(fname,"last/ftltime%d",bnum);
	int ltime = ReadProfileInt(fname);
	FTARTICLEPROPERTY article;
	size_t size = sizeof(FTARTICLEPROPERTY);
	int i;
	for(i = 1; !fseek(fp,size*i*(-1),SEEK_END) ;i++) {
		if (fread(&article,size,1,fp) != 1) break;
		if (article.time <= ltime) break;
	}
	fclose(fp);
	sendsz("107-%d\n",--i);
}

void Channel::ft_setlasttime()
{
	sendsz("102-Enter Freetalk board number.\n");
	int bnum = atoi(recvln());
	sendsz("44-Enter time by time_t format. -1 is now.\n");
	time_t ltime = atoi(recvln());
	if (ltime < 0) ltime = time(NULL);
	char fname[MAXPATH];
	sprintf(fname,"last/ftltime%d", bnum);
	if (!WriteProfileInt(fname, ltime)) {
		sendsz("9-Operation failed.\n");
		return;
	}
	sendsz("8-Operation suceeded.\n");
}

void Channel::ft_getlasttime()
{
	char fname[MAXPATH];
	sendsz("102-Enter Freetalk board number.\n");
	sprintf(fname,"last/ftltime%d",atoi(recvln()));
	sendsz("106-%d\n",ReadProfileInt("fname",time(NULL)));
}

void Channel::ft_editarticle()
{
	char fname[MAXPATH];
	sendsz("102-Enter Freetalk board number.\n");
	sprintf(fname,FREETALKDIR"board%d",atoi(recvln()));
	sendsz("109-Enter Freetalk article number.\n");
	int anum = atoi(recvln());
	if (anum < 1) {
		sendsz("9-There is no such article.\n");
		return;
	}
	anum--;
	size_t size = sizeof(FTARTICLEPROPERTY);
	FILE* fp = fopen(fname,"rb+");
	if (!fp) {
		sendsz("9-No such board.\n");
		return;
	}
	if (fseek(fp,size*anum,SEEK_SET) != 0) {
		sendsz("9-Strange number.\n");
		fclose(fp);
		return;
	}
	FTARTICLEPROPERTY article;
	fread(&article,size,1,fp);
	if (strcasecmp(article.id,information.id) != 0 && userlevel < CONFIG_SYSOPLEVEL) {
		sendsz("9-It isn't your article.\n");
		fclose(fp);
		return;
	}
	sendsz("105-Enter Freetalk article.\n");
	string str = recvln();
	if (strcasecmp(str.c_str(),"KILL") == 0) {
	// Kill routine. ø;_;
		FILE* fpnew = fopen(FREETALKDIR"temp","wb");
		int pos = ftell(fp)-size;
		fseek(fp,0,SEEK_SET);
		while(1) {
			if (ftell(fp)==pos) fseek(fp,size,SEEK_CUR);
			if (fread(&article,size,1,fp) != 1) break;
			fwrite(&article,size,1,fpnew);
		}
		fclose(fp);
		fclose(fpnew);
		rename(FREETALKDIR"temp",fname);
		sendsz("8-Operation succeeded.\n");
		return;
	}
	if (str.length() > 63) str[63] = '\0';
	strcpy(article.article,str.c_str());
	strcpy(article.handle,information.handle);
	time(&article.time);
	fseek(fp,size*(-1),SEEK_CUR);
	fwrite(&article,size,1,fp);
	sendsz("8-Operation succeeded.\n");
	fclose(fp);
}

