// webstbbs.cpp
// $Id: webstbbs.cpp,v 1.8 1998/10/01 10:55:08 jyotaro Exp $

#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>
#include <netdb.h>
#include <netinet/in.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <sys/termios.h>
#include <sys/socket.h>
#include <string>
#include <stl.h>
#include "stbbs.h"
#include "../bbsc/client.h"
#include "jcode.h"
#include "urldecode.h"
#include "stl-html.h"

#define CGINAME "webstbbs.cgi"

hash arg;

void auth(Client& client, string id, string pass)
{
	switch (client.Auth(id.c_str(), pass.c_str())) {
	case LOGIN_INVALIDPASSWORD:
		client.Quit();
		throw (string)"顼桼IDϥѥɤ㤤ޤ";
	case LOGIN_CHANNELFULL:
		client.Quit();
		throw (string)"顼ͥ뤬դǤ";
	case LOGIN_UNKNOWNERROR:
		client.Quit();
		throw (string)"顼Υ顼Ǥ";
	default:
		break;
	}
}

int ConnectToServiceHTML()
{
	int sd = ConnectToService();
	if (sd < 0) throw (string)"顼ӥ³ޤ";
	return sd;
}

bool printarticle(Client& client, int prefix, int exception)
{
	// prefix դΥå 18-EOMޤɽ
	// exception褿false֤
	puts("<pre>");
	do {
		client.recvln();
		if ((int)client == exception) return false;
		if ((int)client == prefix) {
			printf("%s\n", client.GetMessageBody());
		}
	} while ((int)client != 18);
	puts("</pre>");
	return true;
}

void read()
{
	int board = atoi(arg["board"]);
	if (board == 0) throw (string)"顼ܡɻ꤬Ǥ";

	int sd = ConnectToServiceHTML();

	Client client(sd);
	auth(client, arg["id"], arg["pass"]);

//	client.SetLastTime(time(NULL) - 60 * 60 * 24);
	BOARDPROPERTY bp;
	if (!client.SetCurrentMessageBoard(board, &bp)) {
		throw (string)"顼ܡɻ꤬Ǥ";
	}

	begin_form(CGINAME);
	print(format("<H2>%s</H2>", bp.lname));
	print((string)"̾" + edittext("subject", "", 50) + "<BR>\n");
	print((string)"ơ<BR>" + textarea("article", " "));
	print(hidden("action", "post"));
	print(hidden("board", arg["board"]));
	print(hidden("id", arg["id"]));
	print(hidden("pass", arg["pass"]));
	print(submit("񤭹"));
	end_form();

	string article;

#ifdef __SGI_STL_STACK
	stack< vector<string>, deque<string> > s;		// articleսɽ
#else
	stack< vector<string> > s;
#endif // __SGI_STL_STACK

	if (client.GetNewArticle(board, article)) {
		do {
			s.push(article);
		} while (client.GetNextArticle(article));
		do {
			puts("<HR>");
			puts("<pre>");
			print(s.top());
			s.pop();
			puts("</pre>");
		} while (!s.empty());
	} else {
		print(format("\"%s\" ˤϥåޤ", bp.lname));
	}
//	client.SetLastTimeLocal(board, time(NULL));

	client.Quit();
}

void post()
{
	int board = atoi(arg["board"]);
	if (board == 0) throw (string)"顼ܡɻ꤬Ǥ";

	int sd = ConnectToServiceHTML();

	Client client(sd);
	auth(client, arg["id"], arg["pass"]);

	if (!client.EnterArticle(board, arg["subject"].c_str(), arg["article"].c_str())) {
		throw (string)"顼񤭹ޤǤ";
	}
	print(
		format("Location: "CGINAME"?action=read&board=%d&id=%s&pass=%s\n\n", 
			board, arg["id"].c_str(), arg["pass"].c_str()));
}

void menu()
{
	int sd = ConnectToServiceHTML();

	Client client(sd);

	auth(client, arg["id"], arg["pass"]);

	puts("<H3>ƥफΤΤ餻</H3>");
	string news;
	if (client.SystemNews(news)) {
		puts("<pre>");
		print(news);
		puts("</pre>");
	}
	puts("<HR>");
	puts("<H3>åܡɰ</H3>");
	puts("<TABLE>");

	BOARDPROPERTY bp;
	if (!client.MessageBoardFirst(&bp)) throw (string)"顼åܡɤޤ";
	do {
		string fnt = "size=-1";
		if (bp.wlevel <= client.GetUserLevel()) fnt += " color=\"#0000ff\"";
		printf("<TR><TD>%s</TD><TD>%s</TD><TD>%s</TD><TD>%s</TD></TR>\n", 
			font(fnt, format("%02d", bp.bnum)).c_str(), 
			font(fnt, bp.sname).c_str(),
			font(fnt, hyperlink(
				format(CGINAME"?action=read&board=%d&id=%s&pass=%s", bp.bnum, arg["id"].c_str(), arg["pass"].c_str()),
				bp.lname)).c_str(),
			font(fnt, format("̤ : %d", client.GetNumberOfNewArticle())).c_str()
		);
	} while (client.MessageBoardNext(&bp));
	
	client.Quit();
	puts("</TABLE>");
}

void login()
{
	if (arg["bbsname"] == "") arg["bbsname"] = "STBBS";
	if (arg["guestid"] == "") arg["guestid"] = "GUEST";

	const char* bbsname = arg["bbsname"].c_str();
	const char* guestid = arg["guestid"].c_str();

	print(format("%s˥󤷤ޤID %sǤ", bbsname, guestid));
	begin_form(CGINAME);
	printf("桼ID : %s<BR>\n", edittext("id").c_str());
	printf("ѥ : %s<BR>\n", editpassword("pass").c_str());
	print(hidden("action", "menu"));
	print(submit(""));
	end_form();
}

void header()
{
	puts("<H2>WebSTBBS</H2>\n<HR>");
}

void footer()
{
	puts("<HR>");
	puts("WebSTBBS Copyright (c) 1998 STBBS Project");
}

int main()
{
	urldecode(arg);

	if (arg["action"] == "post") {
		try {
			post();
		} catch(const string& msg) {
			begin_html("WebSTBBS");
			begin_body("bgcolor=#f0f0f0");
			header();
			print(font("size=+3", msg));
			footer();
			end_body();
			end_html();
		}
		return 0;
	} 

	begin_html("WebSTBBS");
	begin_body("bgcolor=#f0f0f0");
	header();

	try {
		if (arg["action"] == "read") {
			read();
		} else if (arg["action"] == "menu") {
			menu();
		} else if (arg["action"] == "") {
			login();
		} else throw (string)"顼ʸޤ";
	} catch (const string& msg) {
		print(font("size=+3", msg));
	}

	footer();
	end_body();
	end_html();
	return 0;
}
